//=============================================================================
//  quantisizer program example. 
// The program quantized dotted quavers followed by semiquaver to normal jazzy triplet quavers swing.
// The program also triplet quantisizes the opposite way (semiquaver followed by a dotted quaver) into a jazzy feel.
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License version 2.
// Based on the viool.qml
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//=============================================================================

import QtQuick 2.0
import MuseScore 1.0

MuseScore {
   menuPath: "Plugins.test"
   version: "2.0"
   description: qsTr("This plugin is a test and not working properly")


  



   onRun: {
      if (typeof curScore === 'undefined')
        Qt.quit();
  var cursorNext = curScore.newCursor();    
	var cursor = curScore.newCursor();
	
      var startStaff;
      var endStaff;
      var endTick;
	  var AChord;
	  var Len=0;
	  var Pos=0;	
	  var PosNext=0;
	  var LenNext;	  
      var fullScore = false;
      cursor.rewind(1);
	  cursorNext.rewind(1);

	  
      if (!cursor.segment) { // no selection
        fullScore = true;
        startStaff = 0; // start with 1st staff
        endStaff  = curScore.nstaves - 1; // and end with last
      } else {
        startStaff = cursor.staffIdx;
        cursor.rewind(2);
		cursorNext.rewind(2);
        if (cursor.tick == 0) {
          // this happens when the selection includes the last measure of the score.
          endTick = curScore.lastSegment.tick + 1;
        } else {
          endTick = cursor.tick;
        }
        endStaff   = cursor.staffIdx;
      }
      console.log(startStaff + " - " + endStaff + " - " + endTick)

      for (var staff = startStaff; staff <= endStaff; staff++) {
        for (var voice = 0; voice < 4; voice++) {
          cursor.rewind(1); // beginning of selection
		  cursorNext.rewind(1); // beginning of selection
          cursor.voice    = voice;
          cursor.staffIdx = staff;
		  cursorNext.voice=voice;
		  cursorNext.staffIdx = staff;

          if (fullScore) { // no selection
            cursor.rewind(0); // beginning of score
			cursorNext.rewind(0);
			
			};
			if(cursor.tick < endTick-1){
				
			}
			cursorNext.next();
			
          while (cursor.segment && (fullScore || cursor.tick < endTick)) {
		
            if (cursor.element && cursor.element.type == Element.CHORD) {
          
	  		for(var propertyName in cursorNext.element) {
					//console.log(propertyName +' '+ cursorNext.element[propertyName] );
					// propertyName is what you want
					// you can get the value like this: myObject[propertyName]
			};
   
              

            var notes = cursor.element.notes;
			   
			Pos=cursor.tick ;
			PosNext=cursorNext.tick;
		
	
			Len = cursor.element.durationType;
			LenNext=cursorNext.element.durationType;
		
			if (Len==360 && LenNext==120) {
				cursor.element.durationType=320;
				cursorNext.durationType=160;
				//The following line is not allowed (because tick is readonly) if it was, the code might work
				// but maybe somebody have a better suggestion
				//cursorNext.tick=cursorNext.tick-40;
			}
			if(Len==120 && LenNext==360 ){
				cursor.element.durationType=160;
				cursorNext.durationType=320;
				//The following line is not allowed if it was, the code might work, and I could export a better sounding midi file.
				//cursorNext.tick=cursorNext.tick+40;
				
			}					
					
			console.log(' len'+Len+' nextlen'+LenNext +' pos: '+Pos+' next '+PosNext);
					
			
              


     
            } // end if CHORD
            cursorNext.next();
			cursor.next();
			
          } // end while segment
        } // end for voice
      } // end for staff
      Qt.quit();
   } // end onRun
   
   
}
